
var jp_proj_addons_mozilla_at_nicovideoDownloader = {
  // アドオン名
  addon_name: 'nicovideoDownloader',
  // 設定ブランチ名
  conf_branch_name: 'config.jp.proj.addons.mozilla.nicovideoDownloader.',
  // 設定名
  conf_data: {
    // conf: 設定ブランチ名の中の名前
    // def: 未定義の場合の値
    
    // 右クリックメニュー名
    menu_title: {
      conf: 'menu_title',
      def: 'Download FLV/MP4/SWF',
    },
    // タイトル読み込み
    // %% → %
    // %VID% → videoID (sm～)
    // %VTITLE% → videoTitle
    // %EXT_DOT% → 拡張子前のDOT(%EXT%が未定義・空白の場合は空になる) → save_name_ext_dotで指定
    // %EXT% → 拡張子
    // %MTIME% → 現在時刻(msec)
    // %TIME% → 現在時刻(sec)
    // %YEAR% → 現在時刻(Year/4桁)
    // %MON% → 現在時刻(Month/01-12/2桁)
    // %DAY% → 現在時刻(Day/01-31/2桁)
    // %HOUR% → 現在時刻(Hour/24時間/00-23/2桁)
    // %MIN% → 現在時刻(Minits/00-59/2桁)
    // %SEC% → 現在時刻(Second/00-59/2桁)
    // %MSEC% → 現在時刻(MiliSecond)
    save_name: {
      conf: 'save_name',
      def: '%VID%.%VTITLE%%EXT_DOT%%EXT%',
    },
    save_name_ext_dot: {
      conf: 'save_name_ext_dot',
      def: '.',
    },
    // videoTitle読み込みelement
    videoTitle_xpath: {
      conf: 'videoTitle_xpath',
      def: './/div[contains(concat(" ",normalize-space(@class)," "), "videoDetailExpand")]/h2/text()',
    },
    // videoID読み込み用URL
    // %オプションはタイトルと同様に処理
    videoID_url: {
      conf: 'videoID_url',
      def: 'http://flapi.nicovideo.jp/api/getflv?v=%VID%&ts=%MTIME%',
    },
  },
  
  // 設定データ読み込み
  getPrefBranch: function(){
    return Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(this.conf_branch_name);
  },
  
  // 設定読み込み一般
  getPref: function(type,func){
    try{
      var v = func(type.conf);
      if (v == undefined || v == null) return type.def;
      return v;
    } catch (ex) {
      return type.def;
    }
  },
  
  // 真偽 設定値読み込み
  getBoolPref: function(type){
    return this.getPref(type,this.getPrefBranch().getBoolPref);
  },
  
  // 整数 設定値読み込み
  getIntPref: function(type){
    return this.getPref(type,this.getPrefBranch().getIntPref);
  },
  
  // 文字列 設定値読み込み
  getCharPref: function(type){
    return this.getPref(type,this.getPrefBranch().getCharPref);
  },
  
  // 初期化
  init: function(){
    var contextMenu = document.getElementById("contentAreaContextMenu");
    if (!contextMenu){
      return;
    }
    // コンテキストメニューにダウンロード用のアイテム追加
    this._menuItem = document.createElement("menuitem");
    this._menuItem.setAttribute("label", this.getCharPref(this.conf_data.menu_title));
    contextMenu.insertBefore(this._menuItem,contextMenu.firstChild);
    contextMenu.addEventListener("popupshowing",
                                 function(){
                                   jp_proj_addons_mozilla_at_nicovideoDownloader.onPopupShowing(this);
                                 },
                                 false);
  },
  
  /* 実際のダウンロード */
  download: function(aSavename,aTitle,aVideoID,aVideoIDOpt,aVideoID_url,aExtDot){
    var downloader = new jp_proj_addons_mozilla_at_nicovideoDownloader.downloader();
    downloader.download(aSavename,aTitle, aVideoID,aVideoIDOpt,aVideoID_url,aExtDot);
  },
  
  /* メニュー開いたときの操作 */
  onPopupShowing: function(aPopup){
    // 一旦非表示に
    this._menuItem.hidden = true;
    // リンク上のクリックならメニューを表示しない
    // リンク上でも開くなら、次の行を//でコメントアウト
    if (gContextMenu.onLink) return;
    
    // nicovideo.jpかチェック
    var location = content.document.location;
    if (location.href.indexOf("nicovideo.jp/watch/") == -1 &&
        location.href.indexOf("nicovideo.jp/watch_result/") == -1
       ){
      // nicovideo.jpではない = 非表示のまま
      return;
    }
    // videoIDの取得
    var videoID = /nicovideo\.jp\/(watch|watch_result)\/(\w+)/.exec(location.href)[2];
    // videoTitleの取得
    var xtitle = content.document.evaluate(this.getCharPref(this.conf_data.videoTitle_xpath),content.document,null,XPathResult.FIRST_ORDERED_NODE_TYPE,null);
    if (xtitle == null || videoID == null || !xtitle.singleNodeValue){
      alert("ERROR: nicovideoDownloader\nCannot get title or id\nnicovideo.jp is update??\nPlease contact to Ituki Kirihara/NI\nhttp://blog.proj.jp/ituki/");
      return;
    }
    var title = String(xtitle.singleNodeValue.textContent);
    title = title.replace(/<\!\-\-.*?\-\-\>/g,"");
    //title.replace(/[\$\*\?\"\'\/\\\:]/g, "_");
    // ?パラメータオプション取得
    var videoIDopt = "";
    if (/nicovideo\.jp\/(watch|watch_result)\/[^\?]+\?(.+)/.exec(location.href)){
      videoIDopt = /nicovideo\.jp\/(watch|watch_result)\/[^\?]+\?(.+)/.exec(location.href)[2];
    }
    // メニューの有効化
    this._menuItem.setAttribute("oncommand","jp_proj_addons_mozilla_at_nicovideoDownloader.download('"+ this.getCharPref(this.conf_data.save_name) + "','" + title +"','"+ videoID +"','" + videoIDopt + "','" + this.getCharPref(this.conf_data.videoID_url) + "','" + this.getCharPref(this.conf_data.save_name_ext_dot) + "')");
    this._menuItem.hidden = false;
  },
}


// ダウンローダー本体
jp_proj_addons_mozilla_at_nicovideoDownloader.downloader = function(){
    this.SKIP_SELECT_PROMPT = true;
}
  
jp_proj_addons_mozilla_at_nicovideoDownloader.downloader.prototype = {
  // アドオン名
  addon_name: jp_proj_addons_mozilla_at_nicovideoDownloader.addon_name,
  // 設定ブランチ名
  conf_branch_name: jp_proj_addons_mozilla_at_nicovideoDownloader.conf_branch_name,
  // データ種類
  data_type : {
    flv : {
      extention : {
        conf: "ext_flv",
        def: "flv",
      },
      content_type : {
        conf: "ext_flv_ctype",
        def: "video/flv",
      },
    },
    mp4 : {
      extention : {
        conf: "ext_mp4",
        def: "mp4",
      },
      content_type : {
        conf: "ext_mp4_ctype",
        def: "video/mp4",
      },
    },
    swf : {
      extention : {
        conf: "ext_swf",
        def: "swf",
      },
      content_type : {
        conf: "ext_swf_ctype",
        def: "application/x-shockwave-flash",
      },
    },
  },
  
  // 文字列 設定値読み込み
  getCharPref: function(type){
    return jp_proj_addons_mozilla_at_nicovideoDownloader.getCharPref(type);
  },
  
  // 名前変換(サブルーチン)
  transName_to_2: function(val){
    if (val < 10) return '0' + val;
    return '' + val;
  },
  // 名前変換
  transName: function(name,title,id,ext,ext_dot,date){
    var ret = name;
    ret = ret.replace(/%VID%/g,id);
    ret = ret.replace(/%VTITLE%/g,title);
    if (ext == undefined || ext == null || ext == ""){
      ret = ret.replace(/%EXT%/g,"");
      ret = ret.replace(/%EXT_DOT%/g,"");
    }else{
      ret = ret.replace(/%EXT%/g,ext);
      ret = ret.replace(/%EXT_DOT%/g,ext_dot);
    }
    ret = ret.replace(/%MTIME%/g,'' + date.getTime());
    ret = ret.replace(/%TIME%/g,'' + parseInt(date.getTime()/1000));
    ret = ret.replace(/%YEAR%/g,'' + date.getFullYear());
    ret = ret.replace(/%MON%/g,'' + this.transName_to_2(date.getMonth()+1));
    ret = ret.replace(/%DAY%/g,'' + this.transName_to_2(date.getDate()));
    ret = ret.replace(/%HOUR%/g,'' + this.transName_to_2(date.getHours()));
    ret = ret.replace(/%MIN%/g,'' + this.transName_to_2(date.getMinutes()));
    ret = ret.replace(/%SEC%/g,'' + this.transName_to_2(date.getSeconds()));
    ret = ret.replace(/%MSEC%/g,'' + date.getMilliseconds());
    ret = ret.replace(/%%/g,'%');
    return ret;
  },
  // ファイル名依存文字変換
  transFileName: function(str){
    var ret = str;
    ret = ret.replace(/[\$\*\?\"\'\/\\\:]/g, "_");
    return ret;
  },
  
  // リスナ
  getListener: function(){
    var listener = {
      onStartRequest: function(){},
      onDataAvailable: function (aRequest, aContext, aistream, offset, count){
        aContext.wrappedJSObject.onDataAvailable(aRequest, aContext, aistream, offset, count);
      },
      onStopRequest: function(aRequest, aContext, aStatus){
        aContext.wrappedJSObject.onStopRequest(aRequest, aContext, aStatus);
      }
    }
    return listener;
  },
  
  // ダウンロード本体
  download: function(aSavename,aTitle, aVideoID,aVideoIDopt,aVideoID_url,aExtDot){
    this._savename = aSavename;
    this._title = aTitle;
    this._videoID = aVideoID;
    this._videoIDOpt = aVideoIDopt;
    this._videoID_url = aVideoID_url;
    this._ext_dot = aExtDot;
    this._state = 0;
    this._ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
    this._date = new Date();
    this.wrappedJSObject = this;
    // 読み込みデータ初期化
    this.streamData = "";
    // Video ID から Player の URL を取得
    var nicovideoURLSpec = this.transName(aVideoID_url,aTitle,aVideoID,"","",this._date);
    // swf用オプション付加
    if (/^nm/.exec(aVideoID)){
      nicovideoURLSpec += "&as3=1"; /* 20090429 version */
    }
    // 一般オプション付加
    if (aVideoIDopt != ""){
      nicovideoURLSpec += "&" + aVideoIDopt;
    }
    // 設定ファイルDL開始
    var nicovideoURL = this._ioService.newURI(nicovideoURLSpec, null, null);
    var httpChannel = this._ioService.newChannelFromURI(nicovideoURL).QueryInterface(Components.interfaces.nsIHttpChannel);
    httpChannel.requestMethod = "GET";
    httpChannel.redirectionLimit = 0;
    httpChannel.asyncOpen(this.getListener(), this);
  },
  
  // 来たデータを溜める
  onDataAvailable: function(aRequest, aContext, aistream, offset, count){
    aRequest.QueryInterface(Components.interfaces.nsIHttpChannel);
    if(aRequest.responseStatus != 200){
      alert("ERROR: nicovideoDownloader\nConfig File is not Download. No Download...\nPlease retry!\nRetry but cannot download and see this message only, Please contact to Ituki Kirihara/NI\nhttp://blog.proj.jp/ituki/");
      return;
    }
    var sstream = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
    sstream.init(aistream);
    // 読み込み済み内容に追加する
    this.streamData += sstream.read (-1);
    sstream.close ();
  },
  
  // 読み込みが終わったので、処理する
  onStopRequest: function(aRequest, aContext, aStatus){
    if (Components.isSuccessCode(aStatus)) {
      var result = this.streamData;
      this.streamData = "";
      var p = {};
      for each(var a in result.split("&")) {
        if(typeof a != "string") break;
        var t = a.split("=");
        p[t[0]] = t[1];
      }
      var url = unescape(p["url"]);
      // URLが分かったので、実際にセーブする
      this.saveVIDEO(url);
    }else{
      // 何らかの原因で設定ファイルが読み込めなかった
      alert("ERROR: nicovideoDownloader\nDownload URL not get. No Download...\nPlease retry!\nRetry but cannot download and see this message only, Please contact to Ituki Kirihara/NI\nhttp://blog.proj.jp/ituki/");
      this.streamData = "";
    }
  },
  
  // ファイルへの保存
  saveVIDEO: function(aURLSpec){
    // 初期設定ではflvを仮定
    var video_type = this.data_type.flv;
    var media_type = "v";
    // メディアタイプ判別
    if (/\.nicovideo\.jp\/smile\?(.)\=/.exec(aURLSpec)){
      // download from smile video
      media_type = RegExp.$1;
    }else if (/\.nicovideo\.photozou\.jp\/.*\.([A-Za-z0-9\-\_]+)$/.exec(aURLSpec)){
      // フォト蔵
      var ext = RegExp.$1;
      if (ext == "flv") {
        // media_type = "v"; // flv
      }else{
        // other type, unknown
        alert("WARNING! nicovideoDownloader\nphotozou.jp: Unknown type: URL = [" + aURLSpec + "]\nDefault Mode Download FLV");
      }
    }else{
      // どこか分からない
      alert("WARNING! nicovideoDownloader\nDownload From Unknown... Unknown type: URL = [" + aURLSpec + "]\nDefault Mode Download FLV");
    }
    if (media_type){
      if (media_type == "m"){
        // media is mp4
        video_type = this.data_type.mp4;
      }else if (media_type == "s"){
        // media is swf
        video_type = this.data_type.swf;
      }else if (media_type == "v"){
        // media is flv
        video_type = this.data_type.flv;
      }else{
        alert("WARNING! nicovideoDownloader\nUnknown type: media_type = [" + media_type + "]\nDefault Mode Download FLV");
      }
    }
    // ダウンロード値設定
    var aTitle = this.transFileName(this.transName(this._savename,this._title,this._videoID,"","",this._date))
    var videoFileName = this.transFileName(this.transName(this._savename,this._title,this._videoID,this.getCharPref(video_type.extention),this._ext_dot,this._date))
    var videoURL = this._ioService.newURI(aURLSpec, null, null).QueryInterface(Components.interfaces.nsIURL);
    var fileInfo = new FileInfo(videoFileName, videoFileName, aTitle, this.getCharPref(video_type.extention), videoURL);
    // ダウンロードパラメーター設定
    var fpParams = {
      fpTitleKey: "",
      isDocument: false,
      fileInfo: fileInfo,
      contentType: this.getCharPref(video_type.content_type),
      saveMode: GetSaveModeForContentType(this.getCharPref(video_type.content_type)),
      saveAsType: 0,
      file: null,
      fileURL: null
    }
    // ダウンロードダイアログ表示
    if(!getTargetFile(fpParams, this.SKIP_SELECT_PROMPT)){
      return;
    }
    // 実ファイルダウンロード
    var fileURL = fpParams.fileURL || makeFileURI(fpParams.file);
    var persist = makeWebBrowserPersist();
    var nsIWebBrowserPersist = Components.interfaces.nsIWebBrowserPersist;
    persist.persistFlags = nsIWebBrowserPersist.PERSIST_FLAGS_REPLACE_EXISTING_FILES |
                           nsIWebBrowserPersist.PERSIST_FLAGS_FROM_CACHE |
                           nsIWebBrowserPersist.PERSIST_FLAGS_AUTODETECT_APPLY_CONVERSION;
    var transfer = Components.classes["@mozilla.org/transfer;1"].createInstance(Components.interfaces.nsITransfer);
    transfer.init(fileInfo.uri, fileURL, "", null, null, null, persist);
    persist.progressListener = transfer;
    persist.saveURI(fileInfo.uri, null, null, null, "", fileURL);
  },
}

/* 初期化*/
jp_proj_addons_mozilla_at_nicovideoDownloader.init();

